#!/usr/bin/env python3

import socketserver
import os
import cmd
from rise import *

HOST, PORT = '', 9999

class CmdTCPServer(socketserver.ThreadingMixIn, socketserver.TCPServer):
    class __CmdTCPHandler(socketserver.BaseRequestHandler):
        def handle(self):
            self.inf = open(os.devnull, 'r', 1)
            self.outf = open(os.devnull, 'w', 1)
            os.dup2(self.request.fileno(), self.inf.fileno())
            os.dup2(self.request.fileno(), self.outf.fileno())
            cmd = self.server.cmd_handler(stdin=self.inf, stdout=self.outf)
            cmd.cmdloop()
            
        def finish(self):
            # do not leave FDs open
            if self.inf:
                self.inf.close()
            if self.outf:
                self.outf.close()  
            
    def __init__(self, server_loc, cmd_handler):
        socketserver.TCPServer.__init__(self, server_loc, self.__CmdTCPHandler)
        self.cmd_handler = cmd_handler

if __name__ == "__main__":
    server = CmdTCPServer((HOST, PORT), RISE_Console)
    server.serve_forever()